import java.io.*;
import java.nio.*;
import java.net.*;
import java.util.*;

public class AudioMix {
	//public static ArrayList<PrintWriter> clientes;
	public static ArrayList<HebraCliente> clientes;
	public static int nroClientes; // Clientes conectados
	public static int nroPaquetes; // Paquetes recibidos de la generacion
	public static short[] pozo;

	public static void main (String argv[]) throws IOException {
		Scanner scanner = new Scanner(System.in);
		nroClientes = 0;
		nroPaquetes = 0;
		int id = 0;
		int port;

		clientes = new ArrayList<HebraCliente>();
		pozo = new short[320];

		if (argv.length < 1) {
			System.out.print("Ingrese número de puerto: ");
			port = scanner.nextInt();

		} else {
			port = Integer.parseInt(argv[0]);
		}
		ServerSocket server = new ServerSocket(port);
		System.out.println("El servido ha iniciado...");
		try {
			while (true) {
				Socket cliente = server.accept();
				try {
					clientes.add(new HebraCliente(cliente, id++));
					nroClientes++;
				} catch (IOException e) {
					cliente.close();
				}
			}
		} finally {
			server.close();
		}
	}

	public static void sumarPozo(short[] in) {
		int i;
		for (i = 0;  i < 320; i++) {
			pozo[i] = (short) (pozo[i] + in[i]);
		}
	}

	public static short[] restarPaquete(short[] in) {
		short[] temp = new short[320];
		int i;
		for (i = 0;  i < 320; i++) {
			temp[i] = (short) (pozo[i] - in[i]);
		}
		return temp;
	}

	public static synchronized boolean ready() {
		return nroPaquetes == nroClientes;
	}
}

class HebraCliente extends Thread {
	public Socket socketCliente;
	private DataInputStream in;
	private DataOutputStream out;
	private int id;
	public byte[] packet;
	public short[] packet2;

	public HebraCliente (Socket s, int n) throws IOException {
		packet = new byte[640];
		packet2 = new short[320];
		socketCliente = s;
		id = n;
		System.out.println("Entró nuevo cliente " + id);
		in = new DataInputStream(socketCliente.getInputStream());
		out =  new DataOutputStream(socketCliente.getOutputStream());

		start();
	}

	public void run() {
		int inc = 0;

		try {
			out.writeBytes("id = " + id + "\n");
			while (true) {
				inc = in.read(packet, 0, 640);
				System.out.println("Llego nuevo paquete "+id);
				ByteBuffer.wrap(packet).order(ByteOrder.LITTLE_ENDIAN).asShortBuffer().get(packet2);
				String exit = new String(Arrays.copyOfRange(packet, 0, 4));
				if ("exit".equals(exit)) {
					System.out.println("Cliente " + id + " se desconectó.");
					AudioMix.nroClientes--;
					AudioMix.clientes.remove(this);
					return;
				}
				if (inc == 640) {
					AudioMix.nroPaquetes++;
					AudioMix.sumarPozo(packet2);
				}

				while (!AudioMix.ready()) {
				}

				System.out.println("Llegaron todos los paquetes: " + AudioMix.nroPaquetes + ".");
				short[] temp = AudioMix.restarPaquete(packet2);
				byte[] temp2 = new byte[640];
				ByteBuffer.wrap(temp2).order(ByteOrder.LITTLE_ENDIAN).asShortBuffer().put(temp);
				
				//out.writeBytes("paquete: \n");
				out.write(temp2, 0, 640);
				//out.writeBytes("fin: \n");
				AudioMix.nroPaquetes = 0;	
			}
		} catch (Exception e) {
		}
	}
}
