#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/wait.h>
#include <signal.h>
#include <errno.h>
#include <pthread.h>

int pfd_arecord[2], pid_arecord;
int pfd_aplay[2], pid_aplay;
FILE *pipe_arecord, *pipe_aplay;
pthread_t grab_id, repr_id;
int s;

static pthread_mutex_t lock = PTHREAD_MUTEX_INITIALIZER;



void exec_arecord() {
	if (pipe(pfd_arecord) < 0) {
		perror("pipe1");
		exit(-1);
	}

	if ((pid_arecord = fork()) < 0) {
		perror("fork1");
		exit(-1);
	}

	if (pid_arecord == 0) {
		int junk;

		dup2(pfd_arecord[1], 1);
		close(pfd_arecord[0]);
		junk = open("/dev/null", O_WRONLY);
		dup2(junk, 2);
		execlp("arecord", "arecord", "--format=S16_LE", "-t" ,"raw", (char *) 0);
		perror("exec1");
		exit(-1);
		//arecord --format=S16_LE -t raw 
	}

	close(pfd_arecord[1]);

	pipe_arecord = fdopen(pfd_arecord[0], "r");
}

void exec_aplay() {
	if (pipe(pfd_aplay) < 0) {
		perror("pipe2");
		exit(-1);
	}

	if ((pid_aplay = fork()) < 0) {
		perror("fork2");
		exit(-1);
	}

	if (pid_aplay == 0) {
		int junk;

		dup2(pfd_aplay[0], 0);
		close(pfd_aplay[1]);
		junk = open("/dev/null", O_WRONLY);
		dup2(junk, 2);
		execlp("aplay", "aplay", "-r", "8000", "--format=S16_LE", (char *) 0);
		perror("exec2");
		exit(-1);
	}

	close(pfd_aplay[0]);

	pipe_aplay = fdopen(pfd_aplay[1], "w");
}

void *grabador(void *arg) {
	FILE *o;
	short paquete[320];
	o = fopen("a.raw", "w");
	
	if (o == NULL) {
		perror("fopen");
		exit(1);
	}

	sleep(1);

	int i = 0;
	int u;
	while (1) {
		printf("Hola1\n");
		u = fread(&paquete, sizeof(paquete), 1, pipe_arecord);
		printf("Hola2\n");

		while (u == 0) {
			//sleep(1);
			if(i++ == 2) {
				printf("Hola3\n");
				i = 0;
			}
			
		}
		//fwrite(&paquete, sizeof(paquete), 1, o);
		write(s, &paquete, sizeof(paquete));
		printf("Antes Mutex_grab\n");
		pthread_mutex_lock(&lock);
		printf("Despues Mutex_grab\n");

	}
	fclose(o);
}

void *reproductor(void *arg) {
	//pthread_join(grab_id, NULL);
	sleep(2);

	FILE *in;
	short paquete[320];
	in = fopen("a.raw", "r");

	if (in == NULL) {
		perror("fopen");
		exit(1);
	}

	int i;
	//for (i = 0; i < 30; i++) {
	printf("Antes del while\n");
	while (1) {

		//while ((fread(&paquete, sizeof(paquete), 1, in)) == 0) {
		while ((read(s, &paquete, sizeof(paquete))) == 0) {
			//sleep(1);
		}
		printf("Llego nuevo paquete\n");
		int a = fwrite(&paquete, sizeof(paquete), 1, pipe_aplay);
		printf("Antes Mutex_rep\n");
		pthread_mutex_unlock(&lock);
		printf("Despues Mutex_rep\n");
	}
	fclose(in);	
}

void conectar_servidor(char* addr, char* port) {
	int len;

	struct hostent *hp;
	struct sockaddr_in name;
	printf("Debug_conectar_servidor\n");
	/* Buscar la direccion del servidor.*/
	if  ((hp = gethostbyname(addr)) == NULL) {
	    name.sin_addr.s_addr = inet_addr(addr);
	    if ((hp = gethostbyaddr((void *)&name.sin_addr.s_addr, sizeof(name.sin_addr.s_addr),AF_INET)) == NULL) {
			fprintf(stderr, "No se pudo hallar el servidor: %s\n", addr);
			exit(-1);
	    }
	}

    /* Crear un socket en el dominio INET.*/
    s = socket(AF_INET, SOCK_STREAM, 0);
	printf("Debug_Socket\n");

    /* Crear la direccion del servidor. */
    name.sin_family = AF_INET;
    name.sin_port = htons(atoi(port));
    memcpy(&name.sin_addr, hp->h_addr_list[0], hp->h_length);
    len = sizeof(struct sockaddr_in);

    /* Conectar al servidor. */
    connect(s, (struct sockaddr *) &name, len);
}

static void sig_handler(int signo) {
    if (signo == SIGINT) {
        char* ex = "exit";
        write(s, ex, sizeof(ex));
        exit(-1);
    }
    return;
}

void finalizar() {
    printf("\nCerrando la aplicacion...\n");

	kill(pid_arecord, 9);
	kill(pid_aplay, 9);
	waitpid(pid_arecord, NULL, 0);
	waitpid(pid_aplay, NULL, 0);
	fclose(pipe_arecord);
	fclose(pipe_aplay);
	close(s);
}

int main(int argc, char *argv[]) {
	int ret;

	if (argc != 3) {
		printf("Uso: %s <server> <puerto>\n", argv[0]);
		exit(-1);
	}

	printf("Iniciando cliente...\n");
	conectar_servidor(argv[1], argv[2]);

    atexit(finalizar);


	/* Ejecutar arecord */
	exec_arecord();

	
	/* Ejecutar aplay */
	exec_aplay();

	/* Iniciar hilo grabador */
	ret = pthread_create(&grab_id, NULL, grabador, NULL);
	if (ret != 0) {
		perror("pthread_create 1");
		exit(1);
	}

	/* Iniciar hilo reproductor */
	ret = pthread_create(&repr_id, NULL, reproductor, NULL);
	if (ret != 0) {
		perror("pthread_create 2");
		exit(1);
	}

	/* Esperar que se termine de reproducir */
	pthread_join(repr_id, NULL);
	sleep(4);

	/*
	kill(pid_arecord, 9);
	kill(pid_aplay, 9);
	waitpid(pid_arecord, NULL, 0);
	waitpid(pid_aplay, NULL, 0);
	fclose(pipe_arecord);
	fclose(pipe_aplay);
	close(s);
	*/
	exit(0);
}
